using System.Net.Http.Headers;
using System.Text;
using VeterinaryContracts.ViewModels;
using Newtonsoft.Json;

namespace VeterinaryShowDoctorApp
{
	public static class APIDoctor
	{
		private static readonly HttpClient _doctor = new();
		public static DoctorViewModel? Doctor { get; set; } = null;
		public static void Connect(IConfiguration configuration)
		{
			_doctor.BaseAddress = new Uri(configuration["IPAddress"]);
			_doctor.DefaultRequestHeaders.Accept.Clear();
			_doctor.DefaultRequestHeaders.Accept.Add(new
		   MediaTypeWithQualityHeaderValue("application/json"));
		}
		public static T? GetRequest<T>(string requestUrl)
		{
			var response = _doctor.GetAsync(requestUrl);
			var result = response.Result.Content.ReadAsStringAsync().Result;
			if (response.Result.IsSuccessStatusCode)
			{
				return JsonConvert.DeserializeObject<T>(result);
			}
			else
			{
				throw new Exception(result);
			}
		}
		public static void PostRequest<T>(string requestUrl, T model)
		{
			var json = JsonConvert.SerializeObject(model);
			var data = new StringContent(json, Encoding.UTF8,"application/json");
			var response = _doctor.PostAsync(requestUrl, data);
			var result = response.Result.Content.ReadAsStringAsync().Result;
			if (!response.Result.IsSuccessStatusCode)
			{
				throw new Exception(result);
			}
		}
	}
}
